document.addEventListener("DOMContentLoaded", function(event) {
    // Overwrite each audio controll methods because audio object must be controlled by custom method.
    var mediaElement = document.defaultView.HTMLMediaElement.prototype;
    audioControlLoadCallbackBackup = mediaElement.load;
    audioControlPlayCallbackBackup = mediaElement.play;
    audioControlPauseCallbackBackup = mediaElement.pause;
    audioControlCanPlayTypeCallbackBackup = mediaElement.canPlayType;
    audioControlClickCallbackBackup = mediaElement.click;

    console.debug("media event will be replaced.");
    mediaElement.load = audioControlLoadCallback;
    mediaElement.play = audioControlPlayCallback;
    mediaElement.pause = audioControlPauseCallback;
    mediaElement.canPlayType = audioControlCanPlayTypeCallback;
    mediaElement.click = audioControlClickCallback;
});

var audioControlLoadCallbackBackup;
var audioControlPlayCallbackBackup;
var audioControlPauseCallbackBackup;
var audioControlCanPlayTypeCallbackBackup;
var audioControlClickCallbackBackup;

function audioControlLoadCallback() {
    console.debug("audioControlLoadCallback called: id = " + this.getAttribute('reader_audio_id'));
    return audioControlLoadCallbackBackup.apply(this);
};
function audioControlPlayCallback() {
    console.debug("audioControlPlayCallback called: id = " + this.getAttribute('reader_audio_id'));
    return audioControlPlayCallbackBackup.apply(this);
};
function audioControlPauseCallback() {
    console.debug("audioControlPauseCallback called: id = " + this.getAttribute('reader_audio_id'));
    return audioControlPauseCallbackBackup.apply(this);
};
function audioControlCanPlayTypeCallback() {
    console.debug("audioControlCanPlayTypeCallback called: id = " + this.getAttribute('reader_audio_id'));
    return audioControlCanPlayTypeCallbackBackup.apply(this);
};
function audioControlClickCallback() {
    console.debug("audioControlClickCallback called: id = " + this.getAttribute('reader_audio_id'));
    return audioControlClickCallbackBackup.apply(this);
};
