document.addEventListener("DOMContentLoaded", function(event) {
    change_stylesheet_retry_count = 0;
    change_stylesheets_iOS(document);
    change_audio_tag_iOS(document);
}, false);

var change_stylesheet_retry_count;

function change_default_font(rule) {
    var new_font_name;
    var fonts;
    var new_font_family = "";
    if(rule.style.fontFamily) {
	fonts = rule.style.fontFamily.split(",");
	for (var k = 0; k < fonts.length; k++) {
	    var font_name = fonts[k];
	    font_name = font_name.trim();
	    new_font_name = font_name;
	    if (font_name == "sans-serif"){
	        new_font_name = defaultSansSerifSystemFontName + ', ' + font_name;
                if (defaultSansSerifSystemFontNameAlt) {
                    new_font_name = defaultSansSerifSystemFontNameAlt + ', ' + new_font_name;
                }
            }
	    else if(font_name == "serif" || font_name == "monospace" || font_name == "cursive" || font_name == "fantasy") {
	        new_font_name = defaultSerifSystemFontName + ', ' + font_name;
                if (defaultSerifSystemFontNameAlt) {
                    new_font_name = defaultSerifSystemFontNameAlt + ', ' + new_font_name;
                }
            }
	    if(k == 0){
	        new_font_family = new_font_name;
	    }
	    else{
	        new_font_family = new_font_family + ", " + new_font_name;
	    }
	}
	rule.style.fontFamily = new_font_family;
    }
}

function change_stylesheet_iOS(stylesheet){
    var rules = stylesheet.cssRules;
    if(rules){
	for(var j = 0; j < rules.length; j++) {
	    var rule = rules[j];
	    if(rule.type == CSSRule.IMPORT_RULE){
	        change_stylesheet_iOS(rule.styleSheet);
	    }
	    if(rule.type == CSSRule.STYLE_RULE){
	        change_default_font(rule);
	    }
	}
    }
}
function change_stylesheets_iOS(doc){
    var length = doc.styleSheets.length;
    if (length === 0) {
        if (++change_stylesheet_retry_count < 10) {
            setTimeout(function () {change_stylesheets_iOS(doc);}, 50);
        }
        return;
    }
    for(var i = 0 ; i < length; i++) {
	var styleSheet = doc.styleSheets[i];
	change_stylesheet_iOS(styleSheet);
    }
}
function setEventToMediaTags(tags) {
    var i;
    var tag;
    for (i = 0; i < tags.length; i++) {
        tag = tags[i];
        tag.setAttribute("preload", "metadata");
    }
}
function change_audio_tag_iOS (doc) {
    var tagAudios = doc.getElementsByTagName("audio");
    var tagVideos = doc.getElementsByTagName("video");
    setEventToMediaTags(tagAudios);
    setEventToMediaTags(tagVideos);
}
